/***********************************************
************************************************
**                                            **
** mamot                                      **
** a program for HMM modelling                **
** 2008, Mauro C. Delorenzi                   **
**                                            **
************************************************
************************************************

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

extern class ModelFB model;
extern bool bfileoutput; 
extern long seedran2;
#include "GenMain.h"
int totgenpos;

// ---------------------------------------------------------------------------
//		 GenMain 				
// ---------------------------------------------------------------------------
void GenMain(int number, int maxlen)
{
  int i;
  FILE *cFpWriteGenSeq=NULL;

  if (bfileoutput) 
  {
    if  ((cFpWriteGenSeq = fopen( "GenSeqs.txt", "w" ))  == NULL )
     {cerr << "\n could not open the file  GenSeqs for writing"<<endl; exit(1);}
  } 

  if (seedran2>0) {seedran2=-1*seedran2;}

  for (i=1; i<=number; i++)
    {
      cout << ">random_seq." << i << endl;
       if (bfileoutput) {model.GenerateSequence(cFpWriteGenSeq, i, maxlen);}
	   else {model.GenerateSequenceB(i, maxlen);}
      cout << "\n";
    }
}
/* GenMain
************************************/
// ---------------------------------------------------------------------------


