/***********************************************
************************************************
**                                            **
** mamot                                      **
** a program for HMM modelling                **
** 2008, Mauro C. Delorenzi                   **
**                                            **
************************************************
************************************************

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "read.seqfile.h"

extern FILE * cFpReadSeq; // must be open for all seqs
extern int	   Code[];
//extern bool	   verbose;	
extern class ModelFB model;

// ---------------------------------------------------------------------------
//		 ReadSeq 					
// ---------------------------------------------------------------------------
bool  ReadSeq (int seqNb, int &seqLen, int Seq[], bool &completedFile, char SeqName[])			
{
int	 a, i=0, k, t=0, u=0;
static int	c; 
bool initiated,stopProtein, overlong, error;

stopProtein = false;
initiated = false;
overlong = false; 
error = false;

if (seqNb == 1)  c = (int) '.';

while (( !completedFile) && (i < kMaxSeqLen) && (!stopProtein ))   
    {	
    if (strchr (">", (char) c )!= NULL )  
       {
	   u++;
	   if (1 < u) {cerr << "\nWarning in Reading Sequence " << SeqName << " : Multiple \">\" Symbols?\n";}
	   if (initiated) 
	 	 {
		 stopProtein = true;  
		 //if (i == 0) {cerr << "\nWarning: sequence  " << SeqName << "  is of length zero\n";}
 		 }
	   else
	 	{
	    k = 0;
	    c = (int) fgetc( cFpReadSeq );
	    while ((c != (int)'\n') && (c  != EOF))  
	      {
	      if (k < kMaxSeqName) {SeqName[k] = (char) c; t=k;}
	      c = (int) fgetc( cFpReadSeq );
	      k++;
	      }
	    SeqName[t+1] = '\0'; 
	    }
      } 
//   if (strchr ("abcdefghijklmnopqrstuvwxyz", c )!= NULL ) { c = c - 32;} // conversion to capital letter
     
   if (strchr ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz", c )!= NULL )
      {
	  i++;
	  if (i <= kMaxSeqLen)
	    {
	    initiated = true; u=0;
	    a=c;
	    if ((Code[a]> 0) && (Code[a] <= model.nbLetters)){Seq[i]= Code[a];}
	    else
	       {
		   cerr << "Error: Non expected letter {" << c << "=" << (char) c << "} at Position " << i << 
		      " in Sequence " << seqNb << " named: " << SeqName  << endl; 
		   cerr << "Code[letter] = "  << Code[a] << " model.nbLetters=" << model.nbLetters << endl; 
  		   error=true;
		   Seq[i] = 0;
	       }     
	     }
	  else
	    {
	    cerr << "\nSequence too long, sequence: " << seqNb << endl; 
	    overlong = true;
	    while ((c != (int)'>') && (c  != EOF)) {c = (int) fgetc( cFpReadSeq );}
	    }	
      }
     
   if ((!stopProtein ) && (!overlong) && (c  != EOF))   c = (int) fgetc( cFpReadSeq );
   if  (c == EOF)	{completedFile  = true;stopProtein = true;}
   }
seqLen =  i;
if (i == 0) {cerr << "\nWarning: sequence  " << SeqName << "  is of length zero\n";}
if (error) {seqLen = 0;stopProtein = false;}
return (stopProtein);
}

// -----------------------------------------------------------------------------------------

 
